
Foreman - Bug #4140

GET on /API generate 500 error

01/20/2014 08:10 PM - Ohad Levy

Status: Resolved   

Priority: Normal   

Assignee:    

Category: API   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Started GET "/api" for 127.0.0.1 at 2014-01-20 22:09:21 +0200

Processing by Api::V1::HomeController#index as JSON

  Parameters: {"apiv"=>"v1"}

  User Load (0.1ms)  SELECT "users".* FROM "users" WHERE "users"."id" = ? LIMIT 1  [["id", 1]]

Setting current user thread-local variable to admin

  Feature Load (0.1ms)  SELECT "features".* FROM "features" 

ENCRYPTION_KEY is not defined, so encryption is turned off for ComputeResource.

superclass mismatch for class PluginNotFound (TypeError)

/home/ohad/git/foreman/app/services/foreman/plugin.rb:20:in `<module:Foreman>'

/home/ohad/git/foreman/app/services/foreman/plugin.rb:18:in `<top (required)>'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:469:in `load'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:469:in `block in

 load_file'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:639:in `new_cons

tants_in'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:468:in `load_fil

e'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:353:in `require_

or_load'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:502:in `load_mis

sing_constant'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:192:in `block in

 const_missing'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:190:in `each'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:190:in `const_mi

ssing'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:514:in `load_mis

sing_constant'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:192:in `block in

 const_missing'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:190:in `each'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:190:in `const_mi

ssing'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:514:in `load_mis

sing_constant'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:192:in `block in

 const_missing'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:190:in `each'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:190:in `const_mi

ssing'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/inflector/methods.rb:230:in `blo

ck in constantize'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/inflector/methods.rb:229:in `eac

h'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/inflector/methods.rb:229:in `con

stantize'
/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/inflector/methods.rb:260:in `saf

e_constantize'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/core_ext/string/inflections.rb:6

6:in `safe_constantize'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal/params_wrapper.rb:152:in `

_default_wrap_model'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal/params_wrapper.rb:169:in `

_set_wrapper_defaults'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal/params_wrapper.rb:133:in `

inherited'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/abstract_controller/railties/routes_helpers.rb:7:i

n `block (2 levels) in with'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/railties/paths.rb:7:in `block (2

 levels) in with'

/home/ohad/git/foreman/app/controllers/api/v2/plugins_controller.rb:3:in `<module:V2>'

/home/ohad/git/foreman/app/controllers/api/v2/plugins_controller.rb:2:in `<module:Api>'

/home/ohad/git/foreman/app/controllers/api/v2/plugins_controller.rb:1:in `<top (required)>'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:469:in `load'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:469:in `block in

 load_file'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:639:in `new_cons

tants_in'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:468:in `load_fil

e'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:353:in `require_

or_load'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:502:in `load_mis

sing_constant'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:192:in `block in

 const_missing'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:190:in `each'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/dependencies.rb:190:in `const_mi

ssing'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/inflector/methods.rb:230:in `blo

ck in constantize'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/inflector/methods.rb:229:in `eac

h'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/inflector/methods.rb:229:in `con

stantize'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/core_ext/string/inflections.rb:5

4:in `constantize'

/home/ohad/.gem/ruby/gems/apipie-rails-0.0.24/lib/apipie/application.rb:316:in `load_controller_fr

om_file'

/home/ohad/.gem/ruby/gems/apipie-rails-0.0.24/lib/apipie/application.rb:265:in `block in reload_do

cumentation'

/home/ohad/.gem/ruby/gems/apipie-rails-0.0.24/lib/apipie/application.rb:264:in `each'

/home/ohad/.gem/ruby/gems/apipie-rails-0.0.24/lib/apipie/application.rb:264:in `reload_documentati

on'

/home/ohad/.gem/ruby/gems/apipie-rails-0.0.24/lib/apipie/apipie_module.rb:18:in `method_missing'

/home/ohad/git/foreman/app/controllers/api/v1/home_controller.rb:10:in `index'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal/implicit_render.rb:4:in `s

end_action'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/abstract_controller/base.rb:167:in `process_action

'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal/rendering.rb:10:in `proces

s_action'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/abstract_controller/callbacks.rb:18:in `block in p

rocess_action'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:450:in `block (3 le

vels) in _run__3876641735367710996__process_action__1576873676077934148__callbacks'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:215:in `block in _c

onditional_callback_around_6547'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:326:in `around'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:310:in `_callback_a

round_3903'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:214:in `_conditiona

l_callback_around_6547'
/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:438:in `block (2 le

vels) in _run__3876641735367710996__process_action__1576873676077934148__callbacks'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:215:in `block in _c

onditional_callback_around_6546'

/home/ohad/git/foreman/app/models/concerns/foreman/thread_session.rb:33:in `clear_thread'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:214:in `_conditiona

l_callback_around_6546'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:404:in `block in _r

un__3876641735367710996__process_action__1576873676077934148__callbacks'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:215:in `block in _c

onditional_callback_around_6545'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:326:in `around'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:310:in `_callback_a

round_13'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:214:in `_conditiona

l_callback_around_6545'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:403:in `_run__38766

41735367710996__process_action__1576873676077934148__callbacks'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:405:in `__run_callb

ack'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:385:in `_run_proces

s_action_callbacks'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:81:in `run_callback

s'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/abstract_controller/callbacks.rb:17:in `process_ac

tion'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal/rescue.rb:29:in `process_a

ction'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal/instrumentation.rb:30:in `

block in process_action'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/notifications.rb:123:in `block i

n instrument'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/notifications/instrumenter.rb:20

:in `instrument'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/notifications.rb:123:in `instrum

ent'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal/instrumentation.rb:29:in `

process_action'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal/params_wrapper.rb:207:in `

process_action'

/home/ohad/.gem/ruby/gems/activerecord-3.2.16/lib/active_record/railties/controller_runtime.rb:18:

in `process_action'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/abstract_controller/base.rb:121:in `process'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/abstract_controller/rendering.rb:45:in `process'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal.rb:203:in `dispatch'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal/rack_delegation.rb:14:in `

dispatch'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_controller/metal.rb:246:in `block in action

'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/routing/route_set.rb:73:in `call'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/routing/route_set.rb:73:in `dispat

ch'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/routing/route_set.rb:36:in `call'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/routing/mapper.rb:43:in `call'

/home/ohad/.gem/ruby/gems/journey-1.0.4/lib/journey/router.rb:68:in `block in call'

/home/ohad/.gem/ruby/gems/journey-1.0.4/lib/journey/router.rb:56:in `each'

/home/ohad/.gem/ruby/gems/journey-1.0.4/lib/journey/router.rb:56:in `call'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/routing/route_set.rb:608:in `call'

/home/ohad/.gem/ruby/gems/apipie-rails-0.0.24/lib/apipie/static_dispatcher.rb:65:in `call'

/home/ohad/.gem/ruby/gems/rack-openid-1.4.1/lib/rack/openid.rb:99:in `call'

/home/ohad/.gem/ruby/gems/bullet-4.7.1/lib/bullet/rack.rb:10:in `call'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/best_standards_support.

rb:17:in `call'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/etag.rb:23:in `call'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/conditionalget.rb:25:in `call'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/head.rb:14:in `call'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/params_parser.rb:21:in 
`call'

/home/ohad/git/foreman/lib/middleware/catch_json_parse_errors.rb:9:in `call'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/flash.rb:242:in `call'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/session/abstract/id.rb:210:in `context'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/session/abstract/id.rb:205:in `call'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/cookies.rb:341:in `call

'

/home/ohad/.gem/ruby/gems/activerecord-3.2.16/lib/active_record/query_cache.rb:64:in `call'

/home/ohad/.gem/ruby/gems/activerecord-3.2.16/lib/active_record/connection_adapters/abstract/conne

ction_pool.rb:479:in `call'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/callbacks.rb:28:in `blo

ck in call'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:405:in `_run__20229

03484714684845__call__1586532181974285__callbacks'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:405:in `__run_callb

ack'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:385:in `_run_call_c

allbacks'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/callbacks.rb:81:in `run_callback

s'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/callbacks.rb:27:in `cal

l'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/reloader.rb:65:in `call

'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/remote_ip.rb:31:in `cal

l'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/debug_exceptions.rb:16:

in `call'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/show_exceptions.rb:56:i

n `call'

/home/ohad/.gem/ruby/gems/railties-3.2.16/lib/rails/rack/logger.rb:32:in `call_app'

/home/ohad/.gem/ruby/gems/railties-3.2.16/lib/rails/rack/logger.rb:16:in `block in call'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/tagged_logging.rb:22:in `tagged'

/home/ohad/.gem/ruby/gems/railties-3.2.16/lib/rails/rack/logger.rb:16:in `call'

/home/ohad/.gem/ruby/gems/quiet_assets-1.0.2/lib/quiet_assets.rb:18:in `call_with_quiet_assets'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/request_id.rb:22:in `ca

ll'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/methodoverride.rb:21:in `call'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/runtime.rb:17:in `call'

/home/ohad/.gem/ruby/gems/activesupport-3.2.16/lib/active_support/cache/strategy/local_cache.rb:72

:in `call'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/lock.rb:15:in `call'

/home/ohad/.gem/ruby/gems/actionpack-3.2.16/lib/action_dispatch/middleware/static.rb:63:in `call'

/home/ohad/.gem/ruby/gems/railties-3.2.16/lib/rails/engine.rb:484:in `call'

/home/ohad/.gem/ruby/gems/railties-3.2.16/lib/rails/application.rb:231:in `call'

/home/ohad/.gem/ruby/gems/railties-3.2.16/lib/rails/railtie/configurable.rb:30:in `method_missing'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/builder.rb:134:in `call'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/urlmap.rb:64:in `block in call'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/urlmap.rb:49:in `each'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/urlmap.rb:49:in `call'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/content_length.rb:14:in `call'

/home/ohad/.gem/ruby/gems/railties-3.2.16/lib/rails/rack/log_tailer.rb:17:in `call'

/home/ohad/.gem/ruby/gems/rack-1.4.5/lib/rack/handler/webrick.rb:59:in `service'

/usr/share/ruby/webrick/httpserver.rb:138:in `service'

/usr/share/ruby/webrick/httpserver.rb:94:in `run'

/usr/share/ruby/webrick/server.rb:295:in `block in start_thread'

  Rendered api/v1/errors/standard_error.json.rabl (0.3ms)

Completed 500 Internal Server Error in 1834.9ms (Views: 2.1ms | ActiveRecord: 0.5ms)

 this happens regardless of user auth creds

Related issues:

Related to Foreman - Bug #3988: Expected app/services/foreman/plugin.rb to de... Closed 01/09/2014

History

#1 - 01/20/2014 08:11 PM - Ohad Levy
additionally, when hitting /plugins

ActionView::Template::Error (superclass mismatch for class PluginNotFound):

    1: {

    2:   "total": <%= metadata_total.to_json %>,

    3:   "subtotal": <%= metadata_subtotal.to_json %>,

    4:   "page": <%= metadata_page.to_json %>,

    5:   "per_page": <%= metadata_per_page.to_json %>,

  app/services/foreman/plugin.rb:20:in `<module:Foreman>'

  app/services/foreman/plugin.rb:18:in `<top (required)>'

  app/controllers/api/base_controller.rb:42:in `resource_class'

  app/controllers/api/base_controller.rb:46:in `resource_scope'

  app/controllers/api/v2/base_controller.rb:28:in `metadata_total'

  app/views/api/v2/layouts/index_layout.json.erb:2:in `_app_views_api_v__layouts_index_layout_json_erb___10340

01113581568742_69016980'

  app/controllers/api/base_controller.rb:165:in `render_error'

  app/controllers/api/base_controller.rb:19:in `block in <class:BaseController>'

  lib/middleware/catch_json_parse_errors.rb:9:in `call'

#2 - 01/21/2014 08:52 AM - Dominic Cleal

I'm guessing, but perhaps Foreman::Exception has been reloaded, and since app/services/foreman/ is in the autoload_once_paths, we have two

copies of the Foreman::Exception class now in memory?  (Note, autoload_once_paths also causes #3988.)

#3 - 01/22/2014 04:24 PM - Dominic Cleal

- Related to Bug #3988: Expected app/services/foreman/plugin.rb to define Plugin added

#4 - 12/10/2017 09:48 AM - Tomer Brisker

- Status changed from New to Resolved

Seems to work just fine now.
